/*
 * GridBagLayoutDemo.java
 *
 * Created on 2. Mai 2006, 17:23
 */

package swing2layout_complete;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import javax.swing.JButton;
import javax.swing.JPanel;

/**
 *
 * @author  arnd
 */
public class GridBagLayoutDemo extends javax.swing.JFrame {
    
    /** Creates new form GridBagLayoutDemo */
    public GridBagLayoutDemo() {

        //Referenz zu Contentpane holen
        Container pane = getContentPane();  
        
        
        JButton button;
        
        //Layout auf Gridbaglayout setzen
        pane.setLayout(new GridBagLayout());
        
        //GridbagConstraints-Objekt erzeugen
        GridBagConstraints c = new GridBagConstraints();
        
        //Componenten sollen Zellen des Rasters 
        //horizontal fllen
        c.fill = GridBagConstraints.HORIZONTAL;
        
        //Button mit Aufschrift "Button 1" erzeugen
        button = new JButton("Button 1");
        
        //Gewichtung bei horizontaler Vergrerung 0.8
        c.weightx = 0.8;
     
        //In Zelle 0,0 platzieren
        c.gridx = 0;
        c.gridy = 0;
        
        //Button zu Contentpane hinzufgen
        pane.add(button, c);
        
        //Button "Button 2" erzeugen
        //Gewichtung bei horizontaler Vergrerung 0.4
        //In Zelle 1,0 platzieren
        button = new JButton("Button 2");
        c.weightx = 0.4;
        c.gridx = 1;
        c.gridy = 0;
        //Button zu Contentpane hinzufgen
        pane.add(button, c);
        
        //Button "Button 3" erzeugen
        //und in Zelle 2,0 platzieren
        button = new JButton("Button 3");
        c.gridx = 2;
        c.gridy = 0;
        pane.add(button, c);
        
        //Button "Button 4" erzeugen
        //und in Zelle 3,0 platzieren
        button = new JButton("Button 4");
        c.gridx = 3;
        c.gridy = 0;
        pane.add(button, c);
        
        //Button "Button 4 mit langen Namen" erzeugen
        button = new JButton("Button 4 mit langen Namen");
        //Button in y Richtung um 2*40 Pixel vergrern
        c.ipady = 40;      
        //Button soll beim Vergtern des Frames keinen weiteren Platz beanspruchen
        c.weightx = 0.0;
        //Button soll sich ber 2 Zellen in x-Richtung erstrecken
        c.gridwidth = 2;
        //Button in Zelle 0,1 platzieren
        c.gridx = 0;
        c.gridy = 1;
        //Um den Button einen Abstand von je 10 Pixeln an jeder Seite setzen
        c.insets = new Insets(10,10,10,10); 
        //Button zum Frame hinzufgen
        pane.add(button, c);
        
        //Button "5" erzeugen
        button = new JButton("5");
        
        //Innere Fllung auf 0 und Anzeigebreite auf 1 zurcksetzen
        c.ipady = 0;       
        c.gridwidth = 1;
        
        //Gesamten neu verfgbaren Anzeigebereich in y-Richtung verwenden
        c.weighty = 1;   
        
        //Button unten in der Zelle verankern
        c.anchor = GridBagConstraints.PAGE_END; //bottom of space
        
        //ber dem Button Abstand von 10 Pixeln zur darberliegenden Zeile einrichten
        c.insets = new Insets(10,0,0,0);  
        
        //Button in Zelle 1,2 platzieren
        c.gridx = 1;       
        c.gridy = 2;    
        
        //Breite des Buttons soll sich ber restliche Zellen erstrecken
        c.gridwidth = c.REMAINDER;   
        
        //Button soll Anzeigebereich vertikal und horizontal fllen
        c.fill = GridBagConstraints.BOTH;
        
        //Button zum Frame hinzufgen
        pane.add(button, c);
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        
        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        pack();
    }
    // </editor-fold>//GEN-END:initComponents
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
         try {
            javax.swing.UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
        }
        catch (Exception e) {
            System.out.println("LookAndFeel: Class not found!");
        }
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new GridBagLayoutDemo().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    
}
